<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:11 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ObjectFactory (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ObjectFactory (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/model/ObjectFactory.html" target="_top">Frames</a></li>
<li><a href="ObjectFactory.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.model</div>
<h2 title="Interface ObjectFactory" class="title">Interface ObjectFactory</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">ObjectFactory</span></pre>
<div class="block">A factory for creating various kinds of model objects.
 <p>
 An instance of the factory can be injected into a task or plugin by annotating a public constructor or method with <code>javax.inject.Inject</code>. It is also available via <a href="../../../../org/gradle/api/Project.html#getObjects()"><code>Project.getObjects()</code></a>.</div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>&lt;T extends <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api">Named</a>&gt;&nbsp;<br>T</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/model/ObjectFactory.html#named(java.lang.Class,%20java.lang.String)">named</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;type,
     <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)</code>
<div class="block">Creates a simple immutable <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api"><code>Named</code></a> object of the given type and name.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/model/ObjectFactory.html#newInstance(java.lang.Class,%20java.lang.Object...)">newInstance</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends T&gt;&nbsp;type,
           <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;parameters)</code>
<div class="block">Create a new instance of T, using <code>parameters</code> as the construction parameters.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="named(java.lang.Class, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>named</h4>
<pre>&lt;T extends <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api">Named</a>&gt;&nbsp;T&nbsp;named(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;T&gt;&nbsp;type,
                        <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)
                      throws <a href="../../../../org/gradle/api/reflect/ObjectInstantiationException.html" title="class in org.gradle.api.reflect">ObjectInstantiationException</a></pre>
<div class="block">Creates a simple immutable <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api"><code>Named</code></a> object of the given type and name.

 <p>The given type can be an interface that extends <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api"><code>Named</code></a> or an abstract class that 'implements' <a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api"><code>Named</code></a>. An abstract class, if provided:</p>
 <ul>
     <li>Must provide a zero-args constructor that is not private.</li>
     <li>Must not define or inherit any instance fields.</li>
     <li>Should not provide an implementation for <a href="../../../../org/gradle/api/Named.html#getName()"><code>Named.getName()</code></a> and should define this method as abstract. Any implementation will be overridden.</li>
     <li>Must not define or inherit any other abstract methods.</li>
 </ul>

 <p>An interface, if provided, must not define or inherit any other methods.</p>

 <p>Objects created using this method are not decorated or extensible.</p></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../../org/gradle/api/reflect/ObjectInstantiationException.html" title="class in org.gradle.api.reflect">ObjectInstantiationException</a></code> - On failure to create the new instance.</dd><dt><span class="strong">Since:</span></dt>
  <dd>4.0</dd></dl>
</li>
</ul>
<a name="newInstance(java.lang.Class, java.lang.Object...)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>newInstance</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;newInstance(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Class.html?is-external=true" title="class or interface in java.lang">Class</a>&lt;? extends T&gt;&nbsp;type,
                <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>...&nbsp;parameters)
              throws <a href="../../../../org/gradle/api/reflect/ObjectInstantiationException.html" title="class in org.gradle.api.reflect">ObjectInstantiationException</a></pre>
<div class="block">Create a new instance of T, using <code>parameters</code> as the construction parameters.

 <p>The type must be a non-abstract class.</p>

 <p>Objects created using this method are decorated and extensible, meaning that they have DSL support mixed in and can be extended using the `extensions` property, similar to the <a href="../../../../org/gradle/api/Project.html" title="interface in org.gradle.api"><code>Project</code></a> object.</p>

 <p>An @Inject annotation is required on any constructor that accepts parameters because JSR-330 semantics for dependency injection are used. In addition to those parameters provided as an argument to this method, the following services are also available for injection:</p>

 <ul>
     <li><a href="../../../../org/gradle/api/model/ObjectFactory.html" title="interface in org.gradle.api.model"><code>ObjectFactory</code></a>.</li>
     <li><a href="../../../../org/gradle/api/file/ProjectLayout.html" title="interface in org.gradle.api.file"><code>ProjectLayout</code></a>.</li>
     <li><a href="../../../../org/gradle/api/provider/ProviderFactory.html" title="interface in org.gradle.api.provider"><code>ProviderFactory</code></a>.</li>
 </ul></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../../org/gradle/api/reflect/ObjectInstantiationException.html" title="class in org.gradle.api.reflect">ObjectInstantiationException</a></code> - On failure to create the new instance.</dd><dt><span class="strong">Since:</span></dt>
  <dd>4.2</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li>Next Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/model/ObjectFactory.html" target="_top">Frames</a></li>
<li><a href="ObjectFactory.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
